clc
clear all
close all

images=[{'cameraman.jpg'}, {'len_std.jpg'},{'ovgu.jpg'}];
image_index=2;

%% Noise removing from images
 %RGB = imread('saturn.png');
 RGB = imread(images{image_index});;
 I = rgb2gray(RGB);
 % Adding Gaussian noise to Original image
 J = imnoise(I,'gaussian',0,0.025);
 subplot(1,2,1);imshow(I);title('Original image')
 subplot(1,2,2);imshow(J);title('Original image with Gaussian noise')
 % Removing noise with different methods
 % average Filter
 H=fspecial('average',[5 5]);
 I_filt_avg=imfilter(J,H);
 % Gaussian 
 H=fspecial('gaussian',[5 5],3);
 I_filt_gau=imfilter(J,H);
 % Median
 I_filt_med= medfilt2(J,[5 5]);
 % Wiener
 I_filt_wie = wiener2(J,[5 5]);
 % Plotting
 figure
 subplot(2,2,1);imshow(I_filt_avg);title('Filtered by average')
 subplot(2,2,2);imshow(I_filt_gau);title('Filtered by gaussian')
 subplot(2,2,3);imshow(I_filt_wie);title('Filtered by wiener')
 subplot(2,2,4);imshow(I_filt_med);title('Filtered by median')